import java.util.*;
class Eval implements Visitor<Integer>{
  Map<String,Integer> env;
  Map<String,Tree.FunDef> funs = new HashMap<>(); 
  
  @Override public Integer visit(Tree.Prog e){
    for (var fun:e.funs) funs.put(fun.name,fun);
    return e.expr.welcome(this);
  }
  @Override public Integer visit(Tree.Var e){
    return env.get(e.name);
  }
  @Override public Integer visit(Tree.FunCall e){
    var f = funs.get(e.name);
    var newEnv = new HashMap<String,Integer>();
    var argsIt = f.args.iterator();
    var paramIt= e.args.iterator();
    while (argsIt.hasNext()&&paramIt.hasNext()){
      newEnv.put(argsIt.next(),paramIt.next().welcome(this));
    }
    var oldEnv = env;
    env = newEnv;
    var result = f.body.welcome(this);
    env = oldEnv;
    return result;
  }
  @Override public Integer visit(Tree.FunDef e){
    throw new RuntimeException();
  }
  @Override public Integer visit(Tree.MultExpr e){
    return e.op1.welcome(this)*e.op2.welcome(this);
  }
  @Override public Integer visit(Tree.AddExpr e){
    return e.op1.welcome(this)+e.op2.welcome(this);
  }
  
  @Override public Integer visit(Tree.IntLit e){
    return e.n;
  }
}
