import java.util.List;
interface Tree{
  <R> R welcome(Visitor<R> v);

  static class Prog implements Tree{
    List<FunDef> funs;
    Tree expr;
    Prog(List<FunDef> funs, Tree expr){
      this.funs=funs;
      this.expr=expr;
    }
    @Override public <R> R welcome(Visitor<R> v){
      return v.visit(this);
    }
  } 
  static class FunDef implements Tree{
    String name;
    List<String> args;
    Tree body;
    FunDef(String name, List<String> args, Tree body){
      this.name=name;this.args=args;this.body=body;
    }
    @Override public <R> R welcome(Visitor<R> v){
      return v.visit(this);
    }      
  }
  static class FunCall implements Tree{
    String name;
    List<Tree> args;
    FunCall(String name, List<Tree> args){
      this.name=name;this.args=args;
    }
    @Override public <R> R welcome(Visitor<R> v){
      return v.visit(this);
    }      
  }
  static class Var implements Tree{
    String name;
    Var(String name){
      this.name = name;
    }
    @Override public <R> R welcome(Visitor<R> v){
      return v.visit(this);
    }      
  }
  
  static class IntLit implements Tree{
    int n;
    IntLit(int n){
      this.n=n;
    }
    @Override public <R> R welcome(Visitor<R> v){
      return v.visit(this);
    }
  }
  static class MultExpr implements Tree{
    Tree op1;
    Tree op2;
    MultExpr(Tree op1,Tree op2){
      this.op1 = op1;
      this.op2 = op2;
    }
    @Override public <R> R welcome(Visitor<R> v){
      return v.visit(this);
    }

  }
  static class AddExpr implements Tree{
    Tree op1;
    Tree op2;
    AddExpr(Tree op1,Tree op2){
      this.op1 = op1;
      this.op2 = op2;
    }
    @Override public <R> R welcome(Visitor<R> v){
      return v.visit(this);
    }

  }

}
